"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _d3Array = require("d3-array");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DiscreteScale =
/*#__PURE__*/
function () {
  function DiscreteScale() {
    var _this = this;

    _classCallCheck(this, DiscreteScale);

    _defineProperty(this, "getValue", function (x) {
      var range = _this.range,
          domain = _this.domain,
          n = _this.n;
      return range[(0, _d3Array.bisect)(domain, x, 0, n)];
    });

    _defineProperty(this, "setDomain", function (val) {
      _this.x0 = +val[0];
      _this.x1 = +val[1];

      _this.rescale();

      return _this;
    });

    _defineProperty(this, "setRange", function (val) {
      _this.range = val.slice();
      _this.n = _this.range.length - 1;
      return _this;
    });

    this.x0 = 0;
    this.x1 = 1;
    this.domain = [0.5];
    this.range = [0, 1];
    this.n = 1;
  }

  _createClass(DiscreteScale, [{
    key: "rescale",
    value: function rescale() {
      var x0 = this.x0,
          x1 = this.x1,
          n = this.n;
      var i = -1;
      this.domain = new Array(n);

      while (++i < n) {
        this.domain[i] = ((i + 1) * x1 - (i - n) * x0) / (n + 1);
      }
    }
  }]);

  return DiscreteScale;
}();

var _default = DiscreteScale;
exports.default = _default;